/* ***** BEGIN LICENSE BLOCK *****
 * Licensed	under Version: MPL 1.1/GPL 2.0/LGPL	2.1
 * Full	Terms at http://mozile.mozdev.org/license.html
 *
 * Software	distributed	under the License is distributed on	an "AS IS" basis,
 * WITHOUT WARRANTY	OF ANY KIND, either	express	or implied.	See	the	License
 * for the specific	language governing rights and limitations under	the
 * License.
 *
 * The Original	Code is	Playsophy code.
 *
 * The Initial Developer of	the	Original Code is Playsophy
 * Portions	created	by the Initial Developer are Copyright (C) 2002-2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *		James A. Overton <james@overton.ca>
 *		Andreas	Schamberger	<mozile@andreass.net>
 *		Paul Everitt
 *
 * ***** END LICENSE BLOCK ***** */

//indexes of the drop down menus.
const MOZILE_SAVE_PRESET_PAGE = 0;
const MOZILE_SAVE_PRESET_USER = 1;
const MOZILE_SAVE_PRESET_CUSTOM = 2;

const MOZILE_SAVE_CONTENT_PAGE = 0;
const MOZILE_SAVE_CONTENT_CURRENT = 1;

const MOZILE_SAVE_METHOD_LOCAL = 0;
const MOZILE_SAVE_METHOD_DISPLAY = 1;
const MOZILE_SAVE_METHOD_POST = 2;
const MOZILE_SAVE_METHOD_WEBDAV = 3;

	// Fake	Presets
var	PagePresets	= new Object();
PagePresets.preset = "";
PagePresets.saveContent = "page";
PagePresets.saveMethod =	"display";
PagePresets.httpSavePath = "";

var	UserPresets	= new Object();
UserPresets.preset = "";
UserPresets.saveContent = "page";
UserPresets.saveMethod =	"display";
UserPresets.httpSavePath = "http://yahoo.ca";

var	CurrentSettings	= new Object();
CurrentSettings.preset = "";
CurrentSettings.saveContent = "page";
CurrentSettings.saveMethod =	"display";
CurrentSettings.httpSavePath = "";

var _mozilePrefs = "";

	// Initialize the dialog
function mozileInit()	
{
	var	f =	["save.js","init"];
	var	_mozileTarget = opener.mozileGetCurrentTarget();
	
	opener.mozileDebug(f,3,"Initializing");
	try{	

  	netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
      _mozilePrefs = Components.classes["@mozilla.org/preferences-service;1"].
          getService(Components.interfaces.nsIPrefBranch);
  
  	mozileGetUserPresets();
  
  	mozileSetVersionById('version');
  	opener.mozileDebug(f,3,"Target:	"+_mozileTarget);
  	if(_mozileTarget && _mozileTarget!="") {
  		PagePresets = _mozileTarget.document.MOZILE_RSD_CONFIG;
  		CurrentSettings = _mozileTarget.document.MOZILE_CURRENT_CONFIG;
  		switch(CurrentSettings.preset) {
  			case 'page': 
  				mozileSetPreset('page');
  				mozileApplyPresets('page');	
  				break;
  			case 'user':
  				mozileSetPreset('user');
  				mozileApplyPresets('user');
  				break;
  			default:
  				mozileSetPreset('custom');
  				mozileApplyPresets('custom');
  				break;
  		}
  	}
  	else {
  		mozileSetPreset('user');
  		mozileApplyPresets('user');
  	}
  	mozileSaveToBox();
  	opener.mozileDebug(f,3,"Done Initializing");
  	
	} catch(e) {
		opener.mozileDebug(f,3,"Error Initializing: "+e);
	}
}
	
	// Called when the user clicks "OK"
function mozileAccept() {
	var	f =	["save.js","mozileAccept"];
	opener.mozileDebug(f,2,"Accepting...");
	// store all the settings
	try {
  	CurrentSettings.preset=document.getElementById('mozileSavePresets').value;
  	CurrentSettings.saveContent=document.getElementById('mozileSaveContent').value;
  	CurrentSettings.saveMethod=document.getElementById('mozileSaveMethod').value;
  	CurrentSettings.httpSavePath=document.getElementById('mozileSaveTo').value;
		opener.mozileSave();
		opener.mozileDebug(f,2,"Accepted!");
	} catch(e) {
		opener.mozileDebug(f,2,"Save Error: "+e);
	}
}


function getSaveContentIndex( s ) {
  switch ( s ) {
		case "page":
			return MOZILE_SAVE_CONTENT_PAGE;
		default:
			return MOZILE_SAVE_CONTENT_CURRENT;
	}
}
function getSaveMethodIndex( s ) {
  switch ( s ) {
		case "local":
			return MOZILE_SAVE_METHOD_LOCAL;
		case "post":
			return MOZILE_SAVE_METHOD_POST;
		case "webdav":
			return MOZILE_SAVE_METHOD_WEBDAV;
		default:
			return MOZILE_SAVE_METHOD_DISPLAY;
	}
}

function mozileGetUserPresets() {
	UserPresets.saveContent = _mozilePrefs.getCharPref("mozile.saveContentString");
	UserPresets.saveMethod = _mozilePrefs.getCharPref("mozile.saveMethodString");
	UserPresets.httpSavePath = _mozilePrefs.getCharPref("mozile.saveHttpPathString");
}

	// Store the User Preset
function mozileStorePreset(node) {
	var	f =	["save.js","mozileStorePresets"];
	opener.mozileDebug(f,3,"Storing...");
	try{
		// Set local copy
  	UserPresets.saveContent = document.getElementById('mozileSaveContent').value;
  	UserPresets.saveMethod = document.getElementById('mozileSaveMethod').value;
  	UserPresets.httpSavePath = document.getElementById('mozileSaveTo').value;

  	mozileSetPreset("user");
  
  	// Store to the Mozilla preferences
  	netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
  	_mozilePrefs.setCharPref("mozile.saveContentString", document.getElementById('mozileSaveContent').value);
  	_mozilePrefs.setCharPref("mozile.saveMethodString", document.getElementById('mozileSaveMethod').value);
  	_mozilePrefs.setCharPref("mozile.saveHttpPathString", document.getElementById('mozileSaveTo').value);
  	
  	opener.mozileDebug(f,3,"Stored!");
	
	} catch(e) {
		opener.mozileDebug(f,2,"Store Error: "+e);
	}
}


	//When a Preset value is chosen, do some work
function mozilePreset(node)	{
	mozileApplyPresets(node.value);
	CurrentSettings.preset = node.value;
	mozileSaveToBox();
}

	// Change all of the form values to match the chosen Preset
function mozileApplyPresets(preset)	{
	var	presetObj	= new Object();
	switch(preset) {
		case "page":
			presetObj = PagePresets;
			break;
		case "user":
			presetObj = UserPresets;
			break;
		default:
			presetObj = CurrentSettings;
			break;
	}
//	var	saveContent	= mozileIndices[presetObj.saveContent];
//	var	saveMethod = mozileIndices[presetObj.saveMethod];
//	var	path = presetObj.httpSavePath;
	document.getElementById('mozileSaveContent').selectedIndex = getSaveContentIndex( presetObj.saveContent );
	document.getElementById('mozileSaveMethod').selectedIndex = getSaveMethodIndex( presetObj.saveMethod );
	document.getElementById('mozileSaveTo').value =	presetObj.httpSavePath;
}

	// Decide whether or not to show the "Save To" field
function mozileSaveToBox() {
	var	box	= document.getElementById('mozileSaveToBox');
	var	saveMethod = document.getElementById('mozileSaveMethod').value;
	switch(saveMethod) {
		case 'local': box.collapsed=true; break;
		case 'dialog': box.collapsed=true; break;
		case 'post': box.collapsed=false; break;
		case 'webdav': box.collapsed=true; break;
		default: box.collapsed=true; break;
	}
	self.sizeToContent();
}

	// When the content menu changes, just change the Preset menu to "Custom"
function mozileSaveContent(node) {
	mozileSetPreset('custom');
}

	// When the method menu changes, change the Preset menu to "Custom", and show or hide the Save To field
function mozileSaveMethod(node)	{
	mozileSetPreset('custom');
	mozileSaveToBox();
}

	// When the Save To filed changes, do nothing...
function mozileSaveTo(node)	{
	//if(node.value	!= UserPreset['httpSavePath'] && node.value	!= PagePreset['httpSavePath'])	mozileSetPreset('custom');
}

	// Set the Preset menu to the given value
function mozileSetPreset(value)	{
	var	presetMenu = document.getElementById('mozileSavePresets');
	switch(value) {
		case 'page':
			presetMenu.selectedIndex=0;
			break;
		case 0:
			presetMenu.selectedIndex=0;
			break;
		case 'user':
			presetMenu.selectedIndex=1;
			break;
		case 1:
			presetMenu.selectedIndex=1;
			break;
		default:
			presetMenu.selectedIndex=2;
			break;
	}
}
